
package de.ivu.elect.presentation.person;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.person.boundary.TagBoundaryCreate;
import de.ivu.elect.business.person.entity.Tag;
import de.ivu.elect.business.person.entity.TagMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractTagCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractTagCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.TAG_CREATE)
public abstract class AbstractTagCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Tag> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "tagCreateView";

  public static final String VIEW_ID = "/person/tag-create.xhtml";

  public static final String PARENT_VIEW_ID = "/person/tag-search.xhtml";

  @Inject
  protected transient TagBoundaryCreate create;

  protected Tag entity;

  @Inject
  protected transient TagMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Tag());
  }

  

  public Tag getEntity() {
    return entity;
  }

  protected void setEntity(Tag entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.TAG_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Tag entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Tag entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.TAG_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
